#include "cWindowConfig.h"
#include "cInfo.h"
#include "cWindow.h"
#include "vector.h"
#include <vector>
#include "cFont.h"

using namespace std;


//to get access of plot

nMode mode = nColor;
//int old_y = 0;

//nView Mode
cell scale[3] = {
	{ 10, gapLS+gapNUM*0, gapTOP*1, 0.01, 2, 1.0, 0.01, "Scale X.", "%.2f" },
	{ 11, gapLS+gapNUM*1, gapTOP*1, 0.01, 2, 1.0, 0.01, "Scale Y.", "%.2f" },
	{ 12, gapLS+gapNUM*2, gapTOP*1, 0.01, 2, 1.0, 0.01, "Scale Z.", "%.2f" },
};

cell rotate[3] = {
    { 13, gapLS+gapNUM*0, gapTOP*2, -180, 180,-47.0, 0.2, "Rotate around X. (degree)", "%.1f" },
    { 14, gapLS+gapNUM*1, gapTOP*2, -180, 180, 0.0, 0.2, "Rotate around Y. (degree)", "%.1f" },
    { 15, gapLS+gapNUM*2, gapTOP*2, -180, 180,-11.0, 0.2, "Rotate around Z. (degree)", "%.1f" },
};

cell lookat[9] = {
    { 21, gapLS+gapNUM*0, gapTOP*5, -5.0, 5.0, 0.0, 0.01, "(READ ONLY) X pos of the eye point.", "%.2f"},
    { 22, gapLS+gapNUM*1, gapTOP*5, -5.0, 5.0, 0.0, 0.01, "(READ ONLY) Y pos of the eye point.", "%.2f"},
    { 23, gapLS+gapNUM*2, gapTOP*5, -5.0,20.0, 6.0, 0.01, "(READ ONLY) Z pos of the eye point.", "%.2f"},
    { 24, gapLS+gapNUM*0, gapTOP*6, -5.0, 5.0, 0.0, 0.01, "X position of the ref point.", "%.2f"},
    { 25, gapLS+gapNUM*1, gapTOP*6, -5.0, 5.0, 0.0, 0.01, "Y position of the ref point.", "%.2f"},
    { 26, gapLS+gapNUM*2, gapTOP*6, -5.0, 5.0, 0.0, 0.01, "Z position of the ref point.", "%.2f"},
    { 27, gapLS+gapNUM*0, gapTOP*7, -2.0, 2.0, 0.0, 0.01, "X direction of the up vector.", "%.2f"},
    { 28, gapLS+gapNUM*1, gapTOP*7, -2.0, 2.0, 1.0, 0.01, "Y direction of the up vector.", "%.2f"},
    { 29, gapLS+gapNUM*2, gapTOP*7, -2.0, 2.0, 0.0, 0.01, "Z direction of the up vector.", "%.2f"},
};

cell perspective[4] = {
    { 30, gapLS+gapNUM*-1, gapTOP*4, 1.0, 179.0, 70.0, 1.0, "field of view angle (degrees) in y direction.", "%.1f"},
    { 31, gapLS+gapNUM*0, gapTOP*4, -3.0,  3.0,  1.0, 0.01, "field of view in x dir (width/height).", "%.2f"},
    { 32, gapLS+gapNUM*1, gapTOP*4, 0.1, 100.0, 0.01, 0.05, "distance from viewer to near clipping plane.", "%.1f"},
    { 33, gapLS+gapNUM*2, gapTOP*4, 0.1, 100.0,  8.0, 0.05, "distance from viwer to far clipping plane.", "%.1f"},
};

//nAxis mode
cell max[3] = {
	{ 50, gapLS+gapNUM*0, gapTOP*1, -20.0, 20.0, 2.0, 0.02, "Max X.", "%.2f" },
	{ 51, gapLS+gapNUM*1, gapTOP*1, -20.0, 20.0, 2.0, 0.02, "Max Y.", "%.2f" },
	{ 52, gapLS+gapNUM*2, gapTOP*1, -20.0, 20.0, 2.0, 0.02, "Max Z.", "%.2f" },
};

cell min[3] = {
	{ 53, gapLS+gapNUM*0, gapTOP*2, -20.0, 20.0,-2.0, 0.02, "Min X.", "%.2f" },
	{ 54, gapLS+gapNUM*1, gapTOP*2, -20.0, 20.0,-2.0, 0.02, "Min Y.", "%.2f" },
	{ 55, gapLS+gapNUM*2, gapTOP*2, -20.0, 20.0, 0.0, 0.02, "Min Z.", "%.2f" },
};

cell inc[3] = {
	{ 56, gapLS+gapNUM*0, gapTOP*3, 0.05, 5.0, 0.05, 0.01, "Inc X.", "%.2f" },
	{ 57, gapLS+gapNUM*1, gapTOP*3, 0.05, 5.0, 0.05, 0.01, "Inc Y.", "%.2f" },
	{ 58, gapLS+gapNUM*2, gapTOP*3, 0.05, 5.0, 0.05, 0.01, "Inc Z.", "%.2f" },
};

cell loc[3] = {
	{ 59, gapLS+gapNUM*0, gapTOP*4, 0.00, 1.0, 0.5, 0.01, "Loc Ratio X.", "%.2f" },
	{ 60, gapLS+gapNUM*1, gapTOP*4, 0.00, 1.0, 0.5, 0.01, "Loc Ratio Y.", "%.2f" },
	{ 61, gapLS+gapNUM*2, gapTOP*4, 0.00, 1.0, 0.5, 0.01, "Loc Ratio Z.", "%.2f" },
};

cell tinc[3] = {
	{ 62, gapLS+gapNUM*0, gapTOP*6, 0.01, INF, 0.2, 0.01, "Tick Inc X.", "%.2f" },
	{ 63, gapLS+gapNUM*1, gapTOP*6, 0.01, INF, 0.2, 0.01, "Tick Inc Y.", "%.2f" },
	{ 64, gapLS+gapNUM*2, gapTOP*6, 0.01, INF, 0.2, 0.01, "Tick Inc Z.", "%.2f" },
};

cell tick[3] = {
	{ 65, gapLS+gapNUM*0, gapTOP*7, 0.01, 1.0, 0.1, 0.01, "Tick Length X.", "%.2f" },
	{ 66, gapLS+gapNUM*1, gapTOP*7, 0.01, 1.0, 0.1, 0.01, "Tick Length Y.", "%.2f" },
	{ 67, gapLS+gapNUM*2, gapTOP*7, 0.01, 1.0, 0.1, 0.01, "Tick Length Z.", "%.2f" },
};

//nZoom mode
cell zoom =
	{ 90, gapLS+gapNUM*0, gapTOP*1, 0.10, 10.0, 1.0, 0.01, "Zoom In/Out", "%.2f" };

cell center[3] = {
	{ 91, gapLS+gapNUM*0, gapTOP*2, -INF, INF, 0.0, 0.01, "Shift X", "%.2f"},
	{ 92, gapLS+gapNUM*1, gapTOP*2, -INF, INF, 0.0, 0.01, "Shift Y", "%.2f"},
	{ 93, gapLS+gapNUM*2, gapTOP*2, -INF, INF, 0.0, 0.01, "Shift Z", "%.2f"},
};

//nColor
cButton addcolor( 130, gapLEFT, gapTOP*1, "Add");

cell zmin = { 131, gapLS + gapNUM*1, gapTOP*2, -INF, INF, 0.0, 0.01, "Min Z", "%.2f"};
cell zmax = { 132, gapLS + gapNUM*2, gapTOP*2, -INF, INF, 1.2, 0.01, "Max Z", "%.2f"};

//nCamera

cell clattitude = {1000, gapLS + gapNUM*1 , gapTOP*1, -90.0, 90.0, 0.0, 0.5, "Lattitude", "%.1f"};
cell clongitude = {1001, gapLS + gapNUM*1 , gapTOP*2, -INF, INF, 90.0, 0.5, "Longtitude", "%.1f"};
cell cradius = {1002, gapLS + gapNUM*1 , gapTOP*3, 0.1, INF, 6.0, 0.1, "Radius", "%.1f"};

//nFont
cButton f3D(1100, gapLS + gapNUM*0, gapTOP*1, "On");
cButton fFill(1101, gapLS + gapNUM*0, gapTOP*2, "On");

cButton fX( 1103, gapLS + gapNUM*0, gapTOP*4, "On");
cButton fY( 1104, gapLS + gapNUM*1, gapTOP*4, "On");
cButton fZ( 1105, gapLS + gapNUM*2, gapTOP*4, "On");

cell fXColor[3] = {
	{1106, gapLS + gapNUM*0, gapTOP*5, 0, 255, 255, 1, "Red of X axis", "%3.0f"},
	{1107, gapLS + gapNUM*0, gapTOP*5.66, 0, 255, 0, 1, "Green of X axis", "%3.0f"},
	{1108, gapLS + gapNUM*0, gapTOP*6.33, 0, 255, 0, 1, "Blue of X axis", "%3.0f"},
};

cell fYColor[3] = {
	{1116, gapLS + gapNUM*1, gapTOP*5, 0, 255, 0, 1, "Red of Y axis", "%3.0f"},
	{1117, gapLS + gapNUM*1, gapTOP*5.66, 0, 255, 255, 1, "Green of Y axis", "%3.0f"},
	{1118, gapLS + gapNUM*1, gapTOP*6.33, 0, 255, 0, 1, "Blue of Y axis", "%3.0f"},
};

cell fZColor[3] = {
	{1126, gapLS + gapNUM*2, gapTOP*5, 0, 255, 200, 1, "Red of Z axis", "%3.0f"},
	{1127, gapLS + gapNUM*2, gapTOP*5.66, 0, 255, 200, 1, "Green of Z axis", "%3.0f"},
	{1128, gapLS + gapNUM*2, gapTOP*6.33, 0, 255, 200, 1, "Blue of Z axis", "%3.0f"},
};

cell fSize[3] = {
	{1136, gapLS + gapNUM*0, gapTOP*7.33, 0.25, 2.0, 1.0, 0.01, "Size of X axis", "%.2f"},
	{1137, gapLS + gapNUM*1, gapTOP*7.33, 0.25, 2.0, 1.0, 0.01, "Size of Y axis", "%.2f"},
	{1138, gapLS + gapNUM*2, gapTOP*7.33, 0.25, 2.0, 1.0, 0.01, "Size of Z axis", "%.2f"},
};

//nCaption
cTextBox cTitle(	1200, gapLS + gapNUM*0, gapTOP*1, "PSF of monocular diplopia with an 8 mm pupil");

cTextBox cAxis[3] = {
	cTextBox (1201, gapLS + gapNUM*0, gapTOP*2, "X (mm)"),
	cTextBox (1202, gapLS + gapNUM*0, gapTOP*3, "Y (mm)"),
	cTextBox (1203, gapLS + gapNUM*0, gapTOP*4, "PSF"),
};

cell cCorner =
	{ 1204, gapLS+gapNUM*0, gapTOP*6, 0.0, 270.0, 0.0, 90.0, "Orientation", "%.0f" };

//nSide
cButton sOn[6] = {
	cButton ( 1301, gapLS + gapNUM*0, gapTOP*2, "Off"),
	cButton ( 1302, gapLS + gapNUM*0, gapTOP*3, "Off"),
	cButton ( 1303, gapLS + gapNUM*0, gapTOP*4, "Off"),
	cButton ( 1304, gapLS + gapNUM*0, gapTOP*5, "On"),
	cButton ( 1305, gapLS + gapNUM*0, gapTOP*6, "Off"),
	cButton ( 1306, gapLS + gapNUM*0, gapTOP*7, "On"),
};

cButton sGrid[6] = {
	cButton ( 1311, gapLS + gapNUM*1, gapTOP*2, "Off"),
	cButton ( 1312, gapLS + gapNUM*1, gapTOP*3, "Off"),
	cButton ( 1313, gapLS + gapNUM*1, gapTOP*4, "Off"),
	cButton ( 1314, gapLS + gapNUM*1, gapTOP*5, "On"),
	cButton ( 1315, gapLS + gapNUM*1, gapTOP*6, "Off"),
	cButton ( 1316, gapLS + gapNUM*1, gapTOP*7, "On"),
};

cButton sFill[6] = {
	cButton ( 1321, gapLS + gapNUM*2, gapTOP*2, "Off"),
	cButton ( 1322, gapLS + gapNUM*2, gapTOP*3, "Off"),
	cButton ( 1323, gapLS + gapNUM*2, gapTOP*4, "Off"),
	cButton ( 1324, gapLS + gapNUM*2, gapTOP*5, "Off"),
	cButton ( 1325, gapLS + gapNUM*2, gapTOP*6, "Off"),
	cButton ( 1326, gapLS + gapNUM*2, gapTOP*7, "Off"),
};

//pair of ratio and color
bool operator<(const cColorSet& lhs, const cColorSet& rhs)
{
	return (lhs.first < rhs.first);
};

vector<cColorSet> cs;	//vector to store the current color configuration

//cells to store z value and color
//typedef vector<cell> cellVec;
vector<cellVec> zcCell;
vector<cButton> zcDel;
int availID = 140;


GLdouble GetRatio(GLdouble z)
{
	return (z - zmin.value) / (zmax.value - zmin.value);
}

GLdouble GetZ(GLdouble r)
{
	return (zmax.value - zmin.value) * r + zmin.value;
}

cColor fcolor(GLdouble z)
{
	GLdouble r = GetRatio(z);

	const int numSet = cs.size();

	cColorSet max, min;

	for(int s=0; s<numSet-1; s++)
	{
		if (r > cs[s].first && r <= cs[s+1].first)
		{
			min = cs[s];
			max = cs[s+1];
			break;
		}
	}

	if (r <= cs[0].first)
	{
		min = cs[0];
		max = cs[1];
	}

	if (r >= cs[numSet-1].first)
	{
		min = cs[numSet-2];
		max = cs[numSet-1];
	}

	double r2 = (r - min.first) / (max.first - min.first);

	return (max.second - min.second) * r2 + min.second;
}

void initConfig()
{
	//link callback
	glutDisplayFunc(displayConfig);
	glutReshapeFunc(reshapeConfig);
    glutMotionFunc(motionConfig);
    glutMouseFunc(mouseConfig);
	glutKeyboardFunc(keyboardConfig);
	glutIdleFunc(idleConfig);

	glutCreateMenu(menuConfig);
	glutAddMenuEntry("Color", 'c');
	glutAddMenuEntry("", ' ');
	glutAddMenuEntry("Zoom", 'z');
	glutAddMenuEntry("View", 'v');
	glutAddMenuEntry("Camera", 'm');
	glutAddMenuEntry("", ' ');
	glutAddMenuEntry("Axis", 'a');
	glutAddMenuEntry("Font", 'f');
	glutAddMenuEntry("Caption", 'p');
	glutAddMenuEntry("", ' ');
	glutAddMenuEntry("Side", 's');
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	//set the initial color set
	AddColor(GetZ(0.50), cColor(0.0, 1.0, 1.0)); 
	AddColor(GetZ(1.0), cColor(0.2, 0.2, 0.2)); 

	UpdateColor();
}

void AddColor(GLdouble z, cColor c)
{
	cellVec newCells(4);

	const int zLEFT = 50;
	const int zTOP = 25;
	const int cGAP = 45;
	const int cLEFT = zLEFT + cGAP + 5;

	cell_set(&newCells[0], availID+0, zLEFT, gapTOP*3+zTOP*zcCell.size(), -INF, INF, z, 0.01, "Z", "%.2f");
	cell_set(&newCells[1], availID+1, cLEFT+cGAP*0, gapTOP*3+zTOP*zcCell.size(), 0, 255, int(c[0]*255), 1, "Red", "%3.0f");
	cell_set(&newCells[2], availID+2, cLEFT+cGAP*1, gapTOP*3+zTOP*zcCell.size(), 0, 255, int(c[1]*255), 1, "Green", "%3.0f");
	cell_set(&newCells[3], availID+3, cLEFT+cGAP*2, gapTOP*3+zTOP*zcCell.size(), 0, 255, int(c[2]*255), 1, "Blue", "%3.0f");

	zcCell.push_back(newCells);
	cs.push_back(cColorSet(GetRatio(z), c));

	availID+=5;
}

void UpdateColor()
{
	//sync
	int i;
	zcDel.erase(zcDel.begin(), zcDel.end());
	for(i=0; i<cs.size(); i++)
	{
		cs[i].first = GetRatio(zcCell[i][0].value);
		cs[i].second = cColor(	zcCell[i][1].value/255.0,
								zcCell[i][2].value/255.0,
								zcCell[i][3].value/255.0);

		//display the del button
		//TODO this should be changed so that it's not recreated every time
		cButton del(availID+i, zcCell[i][3].x + 40, zcCell[i][3].y, "X");
		zcDel.push_back(del);
	}	
	
	//do a bubble sort, can't use algorthm class due to name "rotate" conflict
	//	this is actually the quickest sort, since most of the time, it will
	//	already be in the sorted order
	for(i=0; i<cs.size(); i++)
	{
		bool change = false;

		for(int j=0; j<cs.size()-1; j++)
		{
			if (cs[j+1] < cs[j])
			{
				//swap
				cColorSet tempCS = cs[j];
				cs[j] = cs[j+1];
				cs[j+1] = tempCS;

				cellVec tempCV = zcCell[j];
				zcCell[j] = zcCell[j+1];
				zcCell[j+1] = tempCV;

				change = true;
			}
		}

		if (!change) break;
	}

}

void UpdateConfig()
{
	//sync with other windows
}

void displayConfig()
{
    glClearColor(0.0f, 0.0f, 0.0f, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
	//Update Setting

	UpdateConfig();

	//Display setting screen

    setfont("helvetica", 18);
	glColor3ub(255, 255, 255);
	
	if (mode == nView)
	{
 		drawstr(gapLEFT, scale[0].y, "Scale:");
		drawstr(gapLEFT, rotate[0].y, "Rotate:");
		drawstr(gapLEFT, perspective[0].y - gapTOP, "Perspective:");
		drawstr(gapLEFT, lookat[0].y, "Eye:");
		drawstr(gapLEFT, lookat[3].y, "Center:");
		drawstr(gapLEFT, lookat[6].y, "Up:");

		int i;
		
		for(i=0; i<3; i++)
		{
			cell_draw(&scale[i]);
			cell_draw(&rotate[i]);
		}

		for(i=0; i<9; i++)
		{
			cell_draw(&lookat[i]);
		}

		for(i=0; i<4; i++)
		{
			cell_draw(&perspective[i]);
		}
	}

	if (mode == nAxis)
	{

 		drawstr(gapLEFT, max[0].y, "Max:");
 		drawstr(gapLEFT, min[0].y, "Min:");
 		drawstr(gapLEFT, inc[0].y, "Axis Inc:");
 		drawstr(gapLEFT, loc[0].y, "Loc:");
		drawstr(gapLEFT, tick[0].y, "Length:");
		drawstr(gapLEFT, tinc[0].y, "Tick Inc:");

		for(int i=0; i<3; i++)
		{
			cell_draw(&max[i]);
			cell_draw(&min[i]);
			cell_draw(&inc[i]);
			cell_draw(&loc[i]);
			cell_draw(&tick[i]);
			cell_draw(&tinc[i]);
		}
	}

	if (mode == nZoom)
	{
 		drawstr(gapLEFT, zoom.y, "Zoom:");
 		drawstr(gapLEFT, center[0].y, "Shift:");

		cell_draw(&zoom);

		cell_draw(&center[0]);
		cell_draw(&center[1]);
		cell_draw(&center[2]);
	}

	if (mode == nColor)
	{
 		drawstr(gapLEFT, zmin.y, "Min / Max:");

		//create the caption for color
		drawstr(zcCell[0][0].x, gapTOP*3, " Z ");
		drawstr(zcCell[0][1].x, gapTOP*3, " R ");
		drawstr(zcCell[0][2].x, gapTOP*3, " G ");
		drawstr(zcCell[0][3].x, gapTOP*3, " B ");

		//render add buttom
		addcolor.Render();

		//draw min/max cell
		cell_draw(&zmin);
		cell_draw(&zmax);

		//draw the color bar
		const int cbTOP = gapTOP*3 + 20;
		const int cbLEFT = gapLEFT;
		
		const int cbWIDTH = 20;
		const int cbHEIGHT = 170;
		
		const int numSTEP = 200;
		
		glBegin(GL_QUAD_STRIP);
		for(int s = numSTEP; s>=0; s--)
		//for(int s = 0; s<=numSTEP; s++)
		{
			//get position
			GLdouble left = cbLEFT;
			GLdouble right = cbLEFT + cbWIDTH;
			GLdouble top = cbTOP + (GLdouble(cbHEIGHT) / numSTEP) * s;

			//find z
			GLdouble r = (GLdouble(s) / numSTEP);
			GLdouble z = zmax.value - (zmax.value - zmin.value) * r;

			//use the ratio to get color
			cColor color = fcolor(z);

			//plot the vert
			glColor3f(color[0], color[1], color[2]);
			glVertex2f(left, top);
			glVertex2f(right, top);
		}
		glEnd();


		//draw the color cells
	    setfont("helvetica", 18);

		for(int i=0; i<zcCell.size(); i++)
		{
			//compute the position
			GLdouble z = zcCell[i][0].value;

			if (z >= zmin.value && z <= zmax.value)
			{
				double y = cbTOP + cbHEIGHT * (1 - GetRatio(z));
	
				for(int j=0; j<4; j++)
				{

					zcCell[i][j].y = y;
					
					cell_draw(&(zcCell[i][j]));

					//yes, it should be negative
					zcCell[i][0].step = (zmin.value - zmax.value) / numSTEP;
				}

				zcDel[i].y = y;

				//render the del button
				zcDel[i].Render();
			}
	

		}

	}

	if (mode == nCamera)
	{
 		drawstr(gapLEFT, clattitude.y, "Lattitude:");
 		drawstr(gapLEFT, clongitude.y, "Longtitude:");
 		drawstr(gapLEFT, cradius.y, "Radius:");

		cell_draw(&clattitude);
		cell_draw(&clongitude);
		cell_draw(&cradius);
	}

	if (mode == nFont)
	{
		drawstr(gapLEFT, f3D.y, "3D:");
		drawstr(gapLEFT, fFill.y, "Fill:");
		drawstr(fX.x, (fFill.y + fX.y) / 2.0, "X");
		drawstr(fY.x, (fFill.y + fY.y) / 2.0, "Y");
		drawstr(fZ.x, (fFill.y + fZ.y) / 2.0, "Z");
		drawstr(gapLEFT, fX.y, "Scale:");
		drawstr(gapLEFT, fXColor[0].y, "Red:");
		drawstr(gapLEFT, fXColor[1].y, "Green:");
		drawstr(gapLEFT, fXColor[2].y, "Blue:");
		drawstr(gapLEFT, fSize[0].y, "Size:");

		f3D.Render();
		fFill.Render();
		fX.Render();
		fY.Render();
		fZ.Render();

		for(int i=0; i<3; i++)
		{
			cell_draw(&fXColor[i]);
			cell_draw(&fYColor[i]);
			cell_draw(&fZColor[i]);
			cell_draw(&fSize[i]);
		}
	}

	if (mode == nCaption)
	{
		drawstr(gapLEFT, cTitle.y, "Title:");
		drawstr(gapLEFT, cAxis[0].y, "X:");
		drawstr(gapLEFT, cAxis[1].y, "Y:");
		drawstr(gapLEFT, cAxis[2].y, "Z:");
		drawstr(gapLEFT, cCorner.y, "Loc:");

		cTitle.Render();
		for(int i=0; i<3; i++)
		{
			cAxis[i].Render();
		}

		cell_draw(&cCorner);
	}

	if (mode == nSide)
	{
		drawstr(gapLS + gapNUM*0, gapTOP*1, "Show");
		drawstr(gapLS + gapNUM*1, gapTOP*1, "Grid");
		drawstr(gapLS + gapNUM*2, gapTOP*1, "Wall");

		//this is actually rotated to into the view of controler
		drawstr(gapLEFT, sOn[0].y, "Bottom:");
		drawstr(gapLEFT, sOn[1].y, "Top:");
		drawstr(gapLEFT, sOn[2].y, "Left:");
		drawstr(gapLEFT, sOn[3].y, "Right:");
		drawstr(gapLEFT, sOn[4].y, "Front:");
		drawstr(gapLEFT, sOn[5].y, "Back:");

		for(int i=0; i<6; i++)
		{
			sOn[i].Render();
			if (sOn[i].IsOn())
			{
				sGrid[i].Render();
				sFill[i].Render();
			}
		}
	}

    glutSwapBuffers();
}

void reshapeConfig(int width, int height)
{
    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0, width, height, 0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glClearColor(0.0, 0.0, 0.0, 0.0);
}

void motionConfig(int x, int y)
{
	if (mode == nView)
	{
		cell_update(&scale[0], old_y-y);
		cell_update(&scale[1], old_y-y);
		cell_update(&scale[2], old_y-y);
    
		cell_update(&rotate[0], old_y-y);
		cell_update(&rotate[1], old_y-y);
		cell_update(&rotate[2], old_y-y);

		//does not allow users to change eye
		//cell_update(&lookat[0], old_y-y);
		//cell_update(&lookat[1], old_y-y);
		//cell_update(&lookat[2], old_y-y);
		cell_update(&lookat[3], old_y-y);
		cell_update(&lookat[4], old_y-y);
		cell_update(&lookat[5], old_y-y);
		cell_update(&lookat[6], old_y-y);
		cell_update(&lookat[7], old_y-y);
		cell_update(&lookat[8], old_y-y);

		cell_update(&perspective[0], old_y-y);
		cell_update(&perspective[1], old_y-y);
		cell_update(&perspective[2], old_y-y);
		cell_update(&perspective[3], old_y-y);
	}

	if (mode == nAxis)
	{
		for(int i=0; i<3; i++)
		{
			cell_update(&max[i], old_y-y);
			cell_update(&min[i], old_y-y);
			cell_update(&inc[i], old_y-y);
			cell_update(&loc[i], old_y-y);
			cell_update(&tick[i], old_y-y);
			cell_update(&tinc[i], old_y-y);
		}
	}

	if (mode == nZoom)
	{
		cell_update(&zoom, old_y-y);

		cell_update(&center[0], old_y-y);
		cell_update(&center[1], old_y-y);
		cell_update(&center[2], old_y-y);
	}

	if (mode == nCamera)
	{
		cell_update(&clattitude, old_y-y);
		cell_update(&clongitude, old_y-y);
		cell_update(&cradius, old_y-y);
	}

	if (mode == nCaption)
	{
		cell_update(&cCorner, old_y-y);
	}

	if (mode == nFont)
	{
		for(int i=0; i<3; i++)
		{
			cell_update(&fXColor[i], old_y-y);
			cell_update(&fYColor[i], old_y-y);
			cell_update(&fZColor[i], old_y-y);
			cell_update(&fSize[i], old_y-y);
		}
	}

	if (mode == nColor)
	{
		cell_update(&zmin, old_y-y);
		cell_update(&zmax, old_y-y);

		for(int i=0; i<zcCell.size(); i++)
		{
			//update z value in reverse
			cell_update(&(zcCell[i][0]), y-old_y);
			for(int j=1; j<4; j++)
			{
				cell_update(&(zcCell[i][j]), old_y-y);
			}
		}

		UpdateColor();
	}

    old_y = y;
    
    RedisplayAll();
}

void keyboardConfig(unsigned char ch, int x, int y)
{
	if (mode == nCaption)
	{
		cTitle.Update(ch);
		for(int i=0; i<3; i++)
		{
			cAxis[i].Update(ch);
		}

		RedisplayAll();
	}

	//cout << (unsigned int)(ch) << endl;

}

void idleConfig()
{
	if (mode == nCaption && selection != 0)
	{
		//to get the flicker on selected textbox
		glutSetWindow(winConfig);
		glutPostRedisplay();
	}
}
/*
void specialSpace(int key, int x, int y)
{
	switch (key)
	{
	}
}
*/
void mouseConfig(int button, int state, int x, int y)
{
	if (mode != nCaption) selection = 0;
	if (selection == cCorner.id) selection = 0;

	if (state == GLUT_DOWN)
	{
	    selection = 0;
	
		if (mode == nView)
		{
			selection += cell_hit(&scale[0], x, y);
			selection += cell_hit(&scale[1], x, y);
			selection += cell_hit(&scale[2], x, y);

			selection += cell_hit(&rotate[0], x, y);
			selection += cell_hit(&rotate[1], x, y);
			selection += cell_hit(&rotate[2], x, y);

			selection += cell_hit(&lookat[0], x, y);
			selection += cell_hit(&lookat[1], x, y);
			selection += cell_hit(&lookat[2], x, y);
			selection += cell_hit(&lookat[3], x, y);
			selection += cell_hit(&lookat[4], x, y);
			selection += cell_hit(&lookat[5], x, y);
			selection += cell_hit(&lookat[6], x, y);
			selection += cell_hit(&lookat[7], x, y);
			selection += cell_hit(&lookat[8], x, y);

			selection += cell_hit(&perspective[0], x, y);
			selection += cell_hit(&perspective[1], x, y);
			selection += cell_hit(&perspective[2], x, y);
			selection += cell_hit(&perspective[3], x, y);
		}

		if (mode == nAxis)
		{
			for(int i=0; i<3; i++)
			{
				selection += cell_hit(&max[i], x, y);
				selection += cell_hit(&min[i], x, y);
				selection += cell_hit(&inc[i], x, y);
				selection += cell_hit(&loc[i], x, y);
				selection += cell_hit(&tick[i], x, y);
				selection += cell_hit(&tinc[i], x, y);
			}
		}

		if (mode == nZoom)
		{
			selection += cell_hit(&zoom, x, y);

			selection += cell_hit(&center[0], x, y);
			selection += cell_hit(&center[1], x, y);
			selection += cell_hit(&center[2], x, y);
		}

		if (mode == nCamera)
		{
			selection += cell_hit(&clattitude, x, y);
			selection += cell_hit(&clongitude, x, y);
			selection += cell_hit(&cradius, x, y);
		}

		if (mode == nFont)
		{
			for(int i=0; i<3; i++)
			{
				selection += cell_hit(&fXColor[i], x, y);
				selection += cell_hit(&fYColor[i], x, y);
				selection += cell_hit(&fZColor[i], x, y);
				selection += cell_hit(&fSize[i], x, y);
			}

			selection += f3D.Hit(x, y);
			
			if (fFill.Hit(x, y))
			{
			    glutSetWindow(winPlot);

				KillFont();
				if (fFill.IsOn())	BuildFont(0.0, true);
				else				BuildFont(0.0, false);
			    
				glutSetWindow(winConfig);
			}
			
			selection += fX.Hit(x, y);
			selection += fY.Hit(x, y);
			selection += fZ.Hit(x, y);
		}

		if (mode == nCaption)
		{
			selection += cTitle.Hit(x, y);
			for(int i=0; i<3; i++)
			{
				selection += cAxis[i].Hit(x, y);
			}

			selection += cell_hit(&cCorner, x, y);
		}

		if (mode == nSide)
		{
			for(int i=0; i<6; i++)
			{
				selection += sOn[i].Hit(x, y);
				selection += sGrid[i].Hit(x, y);
				selection += sFill[i].Hit(x, y);
			}
		}

		if (mode == nColor)
		{
			selection += addcolor.Hit(x, y);

			selection += cell_hit(&zmin, x, y);
			selection += cell_hit(&zmax, x, y);

			for(int i=0; i<zcCell.size(); i++)
			{
				for(int j=0; j<4; j++)
				{
					selection += cell_hit(&(zcCell[i][j]), x, y);
				}

				//TODO work, but not good programming practice
				//	color does not change when clicked
				if (zcDel[i].Hit(x, y) != 0 && zcCell.size() > 2)
				{
					zcCell.erase(zcCell.begin() + i, zcCell.begin() + i + 1);
					zcDel.erase(zcDel.begin() + i, zcDel.begin() + i + 1);
					cs.erase(cs.begin() + i, cs.begin() + i + 1);

					break;
				}

				//since it could overlap, once selection, choose this, jump out
				if (selection != 0) break;
			}

			//process
			if (selection == addcolor.id)
			{
				//add color at mid point
				GLdouble z = (zmax.value - zmin.value) / 2 + zmin.value;
				cColor c = fcolor(z);

				AddColor(z, c);

			}

			//update
			UpdateColor();

		}
	}

	/* //unselect is now handle automatically in Render
	if (state == GLUT_UP)
	{
		if (mode == nColor)
		{
			addcolor.SetHit(false);
		}

		if (mode == nFont)
		{
			f3D.SetHit(false);
			fX.SetHit(false);
			fY.SetHit(false);
			fZ.SetHit(false);
		}
	}
	*/
    
    old_y = y;
    
    RedisplayAll();
}

void menuConfig(int value)
{
	//bool zoomReset = false;

	switch (value)
	{
	case 'a': mode = nAxis;	/*zoomReset = true;*/	break;
	case 'c': mode = nColor;						break;
	case 'v': mode = nView;	/*zoomReset = true;*/	break;
	case 'z': mode = nZoom;							break;
	case 'm': mode = nCamera;						break;
	case 'f': mode = nFont;							break;
	case 'p': mode = nCaption;						break;
	case 's': mode = nSide;							break;
	}

	if (mode != nZoom && zoom.value != 1.0)
	{
		for(int i=0; i<3; i++)
		{
			min[i].value += center[i].value;
			max[i].value += center[i].value;
			min[i].value /= zoom.value;
			max[i].value /= zoom.value;
			inc[i].value *= zoom.value;
			scale[i].value *= zoom.value;
			center[i].value = 0.0;
		}
		zoom.value = 1.0;
	}

	RedisplayAll();
}
/*
void RedisplayAll(void)
{
    glutSetWindow(winMain);
    glutPostRedisplay();
    glutSetWindow(winPlot);
    glutPostRedisplay();
    glutSetWindow(winConfig);
    glutPostRedisplay();
}
*/